package com.nisum.example.controller;

import com.nisum.example.model.Reservation;
import com.nisum.example.service.ReservationService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.MediaType;
import org.springframework.web.bind.annotation.*;
import reactor.core.publisher.Mono;

@RestController
@RequestMapping(ReservationController.ROOM_V_1_RESERVATION) //base string of url
@CrossOrigin //to run angular and spring app locally
public class ReservationController {

    public static final String ROOM_V_1_RESERVATION = "/room/v1/reservation/";

    private final ReservationService reservationService;

    @Autowired
    public ReservationController(ReservationService reservationService) {
        this.reservationService = reservationService;
    }

    @GetMapping(path = "{id}",produces = MediaType.APPLICATION_PROBLEM_JSON_UTF8_VALUE)
    public Mono<Reservation> getReservationById(@PathVariable String id){

        //reservationService.getReservation(roomId)
       // return Mono.just("{}");

        return reservationService.getReservation(id);
    }

    @PostMapping(path = "",produces = MediaType.APPLICATION_JSON_UTF8_VALUE,
    consumes = MediaType.APPLICATION_JSON_UTF8_VALUE)
    public Mono<Reservation> createReservation(@RequestBody Mono<Reservation> reservation){
        //return Mono.just("{}")
             return reservationService.createReservation(reservation);
    }

    @PutMapping(path = "{roomId}",produces = MediaType.APPLICATION_JSON_UTF8_VALUE,
            consumes = MediaType.APPLICATION_JSON_UTF8_VALUE)
    public Mono<String> updatePrice(@PathVariable String roomId,
                                    @RequestBody Mono<Reservation> reservation) {
        return Mono.just("{}");
    }

    @DeleteMapping(path = "{roomId}")
    public Mono<Boolean> deleteReservation(@PathVariable String roomId){
        return Mono.just(true);

    }
}
